# AmoebaAngleForce Class Reference

This class implements an interaction between triplets of particles that varies with the angle between them. More...

`#include <AmoebaAngleForce.h>`

Inheritance diagram for AmoebaAngleForce:

List of all members.

## Classes

class | AngleInfo
| This is an internal class used to record information about an angle.

## Public Member Functions

| AmoebaAngleForce ()
| Create an AmoebaAngleForce.
int | getNumAngles () const
| Get the number of angle stretch terms in the potential function.
void | setAmoebaGlobalAngleCubic (double cubicK)
| Set the global cubic term.
double | getAmoebaGlobalAngleCubic (void) const
| Get the global cubic term.
void | setAmoebaGlobalAngleQuartic (double quarticK)
| Set the global quartic term.
double | getAmoebaGlobalAngleQuartic (void) const
| Get the global quartic term.
void | setAmoebaGlobalAnglePentic (double penticK)
| Set the global pentic term.
double | getAmoebaGlobalAnglePentic (void) const
| Get the global pentic term.
void | setAmoebaGlobalAngleSextic (double sexticK)
| Set the global sextic term.
double | getAmoebaGlobalAngleSextic (void) const
| Get the global sextic term.
int | addAngle (int particle1, int particle2, int particle3, double length, double quadraticK)
| Add an angle term to the force field.
void | getAngleParameters (int index, int &particle1, int &particle2, int &particle3, double &length, double &quadraticK) const
| Get the force field parameters for an angle term.
void | setAngleParameters (int index, int particle1, int particle2, int particle3, double length, double quadraticK)
| Set the force field parameters for an angle term.
void | updateParametersInContext (Context &context)
| Update the per-angle parameters in a Context to match those stored in this Force object.

## Protected Member Functions

ForceImpl * | createImpl () const
| When a Context is created, it invokes this method on each Force in the System.

## Protected Attributes

double | _globalCubicK
double | _globalQuarticK
double | _globalPenticK
double | _globalSexticK

## Detailed Description

This class implements an interaction between triplets of particles that varies with the angle between them.

The interaction is defined by a 6th order polynomial. Only the quadratic term is set per-angle. The coefficients of the higher order terms each have a single value that is set globally.

To use it, create an AmoebaAngleForce object then call addAngle() once for each angle. After an angle has been added, you can modify its force field parameters by calling setAngleParameters(). This will have no effect on Contexts that already exist unless you call updateParametersInContext().

## Constructor & Destructor Documentation

AmoebaAngleForce | ( |  | ) |

Create an AmoebaAngleForce.

## Member Function Documentation

int addAngle | ( | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | double | length,
|  | double | quadraticK |
| ) |  |  |

Add an angle term to the force field.

Parameters:

  | particle1 | the index of the first particle connected by the angle
  | particle2 | the index of the second particle connected by the angle
  | particle3 | the index of the third particle connected by the angle
  | length | the angle measured in degrees
  | quadratic | k the quadratic force constant for the angle, measured in kJ/mol/radian^2

Returns:
  the index of the angle that was added

ForceImpl* createImpl | ( |  | ) | const`[protected, virtual]`

When a Context is created, it invokes this method on each Force in the System.

It should create a new ForceImpl object which can be used by the context for calculating forces. The ForceImpl will be deleted automatically when the Context is deleted.

Implements Force.

double getAmoebaGlobalAngleCubic | ( | void |  | ) | const

Get the global cubic term.

Returns:
  global cubicK term

double getAmoebaGlobalAnglePentic | ( | void |  | ) | const

Get the global pentic term.

Returns:
  global penticK term

double getAmoebaGlobalAngleQuartic | ( | void |  | ) | const

Get the global quartic term.

Returns:
  global quartic term

double getAmoebaGlobalAngleSextic | ( | void |  | ) | const

Get the global sextic term.

Returns:
  global sextic term

void getAngleParameters | ( | int | index,
|  | int & | particle1,
|  | int & | particle2,
|  | int & | particle3,
|  | double & | length,
|  | double & | quadraticK |
| ) |  |  | const

Get the force field parameters for an angle term.

Parameters:

  | index | the index of the angle for which to get parameters
  | particle1 | the index of the first particle connected by the angle
  | particle2 | the index of the second particle connected by the angle
  | particle3 | the index of the third particle connected by the angle
  | length | the equilibrium angle, measured in degress
  | quadratic | k the quadratic force constant for the angle, measured in kJ/mol/radian^2

int getNumAngles | ( |  | ) | const`[inline]`

Get the number of angle stretch terms in the potential function.

void setAmoebaGlobalAngleCubic | ( | double | cubicK | ) |

Set the global cubic term.

Parameters:

  | cubicK | the cubic force constant for the angle

void setAmoebaGlobalAnglePentic | ( | double | penticK | ) |

Set the global pentic term.

Parameters:

  | penticK | the pentic force constant for the angle

void setAmoebaGlobalAngleQuartic | ( | double | quarticK | ) |

Set the global quartic term.

Parameters:

  | quarticK | the quartic force constant for the angle

void setAmoebaGlobalAngleSextic | ( | double | sexticK | ) |

Set the global sextic term.

Parameters:

  | sexticK | the sextic force constant for the angle

void setAngleParameters | ( | int | index,
|  | int | particle1,
|  | int | particle2,
|  | int | particle3,
|  | double | length,
|  | double | quadraticK |
| ) |  |  |

Set the force field parameters for an angle term.

Parameters:

  | index | the index of the angle for which to set parameters
  | particle1 | the index of the first particle connected by the angle
  | particle2 | the index of the second particle connected by the angle
  | particle3 | the index of the third particle connected by the angle
  | length | the equilibrium angle, measured in degrees
  | quadratic | k the quadratic force constant for the angle, measured in kJ/mol/radian^2

void updateParametersInContext | ( | Context & | context | ) |

Update the per-angle parameters in a Context to match those stored in this Force object.

This method provides an efficient method to update certain parameters in an existing Context without needing to reinitialize it. Simply call setAngleParameters() to modify this object's parameters, then call updateParametersInState() to copy them over to the Context.

The only information this method updates is the values of per-angle parameters. The set of particles involved in an angle cannot be changed, nor can new angles be added.

## Member Data Documentation

double _globalCubicK `[protected]`

double _globalPenticK `[protected]`

double _globalQuarticK `[protected]`

double _globalSexticK `[protected]`

The documentation for this class was generated from the following file:

- AmoebaAngleForce.h